--- chan_zap.c.orig	2006-10-13 19:39:04.031234080 -0400
+++ chan_zap.c	2006-10-13 19:43:26.979259904 -0400
@@ -6302,6 +6302,48 @@
 				return NULL;
 			}
 		} else if (p->use_callerid && p->cid_start == CID_START_RING) {
+                        if (p->cid_signalling == CID_SIG_DTMF) {
+                                int i = 0;
+                                cs = NULL;
+                                ast_log(LOG_DEBUG, "Receiving DTMF cid on "
+                                                "channel %s\n", chan->name);
+                                zt_setlinear(p->subs[index].zfd, 0);
+                                res = 2000;
+                                for (;;) {
+                                        struct ast_frame *f;
+                                        res = ast_waitfor(chan, res);
+                                        if (res <= 0) {
+                                                ast_log(LOG_WARNING, "DTMFCID timed out waiting for ring. "
+                                                                "Exiting simple switch\n");
+                                                ast_hangup(chan);
+                                                return NULL;
+                                        }
+                                        f = ast_read(chan);
+                                        if (f->frametype == AST_FRAME_DTMF) {
+                                                dtmfbuf[i++] = f->subclass;
+                                                ast_log(LOG_DEBUG, "CID got digit '%c'\n", f->subclass);
+                                                res = 2000;
+                                        }
+                                        ast_frfree(f);
+
+                                        if (p->ringt_base == p->ringt)
+                                                break;
+
+                                }
+                                dtmfbuf[i] = '\0';
+                                zt_setlinear(p->subs[index].zfd, p->subs[index].linear);
+                                /* Got cid and ring. */
+                                ast_log(LOG_DEBUG, "CID got string '%s'\n", dtmfbuf);
+                                callerid_get_dtmf(dtmfbuf, dtmfcid, &flags);
+                                ast_log(LOG_DEBUG, "CID is '%s', flags %d\n",
+                                                dtmfcid, flags);
+                                /* If first byte is NULL, we have no cid */
+                                if (!ast_strlen_zero(dtmfcid))
+                                        number = dtmfcid;
+                                else
+                                        number = NULL;
+                                /* If set to use V23 Signalling, launch our FSK gubbins and listen for it */
+                        } else {
 			/* FSK Bell202 callerID */
 			cs = callerid_new(p->cid_signalling);
 			if (cs) {
@@ -6472,6 +6514,7 @@
 			} else
 				ast_log(LOG_WARNING, "Unable to get caller ID space\n");
 		}
+		}
 		else
 			cs = NULL;
 
